searchNodes=[{"doc":"Bubblescript Matching Language (BML) BML is a rule language for matching natural language against a rule base. Think of it as regular expressions for sentences. Whereas regular expressions work on individual characters, BML rules primarily work on a tokenized representation of the string.BML ships with a builtin string tokenizer, but for production usage you should look into using a language-specific tokenizer, e.g. to use the output of Spacy's Doc.to_json function.This project is still in development, and as such, the BML syntax is still subject to change.The full documentation on the BML syntax and the API reference is available on hexdocs.pm. To try out BML, check out the demo environment, powered by Phoenix Liveview.ExamplesMatching basic sequences of words:Match stringExampleMatches?hello worldHello, world!yeshello worldWell hello worldyeshello worldhello there worldnohello worldworld hellonoMatching regular expressions:Match stringExampleMatches?/[a-z]+/abcdyesMatch entities, with the help of Spacy and Duckling preprocessing and tokenizing the input:Match stringMatchesDoes not match[person]George BakerHello world[time]I walked to the store yesterdayMy name is JohnRules overviewThe match syntax is composed of adjacent and optionally nested, rules. Each individual has the following syntax:Basic words; only alphanumeric characters and the quote charactersmatching is done on both the lowercased, normalized version of the word, and on the lemmatization of the word.use a dash (-) to match on compound nouns: was-machine matches all of wasmachine, was-machine and was machine.&quot;Literal word sequence&quot;Matches a literal piece of text, possibly spread out over multiple tokens._ without any range specifier, matches 0-5 of any available token, greedy.Stand-alone range specifier[1] match exactly one token; any token[2+] match 2 or more tokens (greedy)[1-3] match 1 to 3 tokens (greedy)[2+?] match 2 or more tokens (non-greedy)[1-3?] match 1 to 3 tokens (non-greedy)Entity tokens: [email] matches a token of type :entity with value.kind == email. Entities are extracted by external means, e.g. by an NLP NER engine like Duckling.Entities are automatically captured under a variable with the same name as the entity's kind.Regex tokens: [/regex/] matches the given regex against the raw text in the tokenOR / grouping constructpizza | fries | chicken - OR-clause on the root level without parens, matches either tokena ( a | b | c ) - use parentheses to separate OR-clauses; matches one token consisting of first a, and then a, b or c.( a )[3+] matches 3 or more token consisting of a( hi | hello )[=greeting] matches 1 token and stores it in greetingPermutation construct&lt; a b c &gt; matches any permutation of the sequence a b c; a c b, or b a c, or c a b, etcStart / end sentence markers[Start] Matches the start of a sentence[End] Matches the end of a sentenceWord collections (&quot;concepts&quot;)@food matches any token in the food collection.@food.subcat matches any token in the given subcategory.Concept compilation is done as part of the parse phase; the concepts compiler must must return an {m, f, a} triple. In runtime, this MFA is called while matching, and thus, it must be a fast function.Part-of-speech tags (word kinds), e.g.%VERB matches any verb%NOUN matches any nounAny other POS Spacy tags are valid as wellRule modifiersAny rule can have a [] block which contains a repetition modifier and/or a capture expression.Entity blocks are automatically captured as the entity kind.SentencesThe expression matching works on a per-sentence basis; the idea is that it does not make sense to create expressions that span over sentences.The builtin sentence tokenizer (BubbleMatch.Sentence.Tokenizer) does not have the concept of sentences, and thus treats each input as a single sentence, even in the existence of periods in the input.However, the prefered way of using this library is by running the input through an NLP preprocessor like Spacy, which does tokenize an input into individual sentences.SigilFor use within Elixir, it is possible to use a ~m sigil which parses the given BML query on compile-time:defmodule MyModule do use BubbleMatch.Sigil def greeting?(input) do BubbleMatch.match(~m&quot;hello | hi | howdy&quot;, input) != :nomatch end endInstallationIf available in Hex, the package can be installed by adding bubble_match to your list of dependencies in mix.exs:def deps do [ {:bubble_match, &quot;~&gt; 0.1.0&quot;} ] endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/bubble_match.","ref":"BubbleMatch.html","title":"BubbleMatch","type":"module"},{"doc":"Match a given input against a BML query.","ref":"BubbleMatch.html#match/2","title":"BubbleMatch.match/2","type":"function"},{"doc":"Parse a string into a BML expression.","ref":"BubbleMatch.html#parse/2","title":"BubbleMatch.parse/2","type":"function"},{"doc":"Parse a string into a BML expression, raises on error.","ref":"BubbleMatch.html#parse!/2","title":"BubbleMatch.parse!/2","type":"function"},{"doc":"","ref":"BubbleMatch.html#t:input/0","title":"BubbleMatch.input/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:match_result/0","title":"BubbleMatch.match_result/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:parse_opt/0","title":"BubbleMatch.parse_opt/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:parse_opts/0","title":"BubbleMatch.parse_opts/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:t/0","title":"BubbleMatch.t/0","type":"type"},{"doc":"A data structure which holds a tokenized sentence.The struct contains the text of the sentence (in the text property), and a list of tokenizations. Normally, a sentence has just one tokenization, but adding entities to the sentence might cause several tokens in the sentence to be replaed with an entity token, thus creating the need for multiple tokenizations (as you still might want to match on the original sentence, e.g. in the case of a falsely identified entitiy)","ref":"BubbleMatch.Sentence.html","title":"BubbleMatch.Sentence","type":"module"},{"doc":"Enrich the given sentence with entities extracted via DucklingThis function takes the output of the Duckling JSON format and enriches the given sentence with the entities that were found using Duckling.","ref":"BubbleMatch.Sentence.html#add_duckling_entities/2","title":"BubbleMatch.Sentence.add_duckling_entities/2","type":"function"},{"doc":"Tokenize an input into individual tokens.As the name suggests, this tokenization is quite naive. It only splits strings on whitespace and punctuation, disregarding any language-specific information. However, for 'basic' use cases, and for our test suite, it is good enough.","ref":"BubbleMatch.Sentence.html#naive_tokenize/1","title":"BubbleMatch.Sentence.naive_tokenize/1","type":"function"},{"doc":"Convert a JSON blob from Spacy NLP data into a list of sentencesThis function takes the output of Spacy's Doc.to_json function and converts it into a list of sentences.","ref":"BubbleMatch.Sentence.html#sentences_from_spacy/1","title":"BubbleMatch.Sentence.sentences_from_spacy/1","type":"function"},{"doc":"","ref":"BubbleMatch.Sentence.html#t:t/0","title":"BubbleMatch.Sentence.t/0","type":"type"},{"doc":"","ref":"BubbleMatch.Sigil.html","title":"BubbleMatch.Sigil","type":"module"},{"doc":"Define the ~m sigil for compile-time parsing of BML expressions.For use within Elixir it is possible to use a ~m sigil which parses the given BML query on compile-time:defmodule MyModule do use BubbleMatch.Sigil def greeting?(input) do BubbleMatch.match(~m&quot;hello | hi | howdy&quot;, input) != :nomatch end end","ref":"BubbleMatch.Sigil.html#sigil_m/2","title":"BubbleMatch.Sigil.sigil_m/2","type":"macro"},{"doc":"A token is a single word or a part of the sentence. A sentence is a sequence of tokens.Each token contains information and metadata that is used to match sentences on, and to extract information from.","ref":"BubbleMatch.Token.html","title":"BubbleMatch.Token","type":"module"},{"doc":"Test whether a token is an entity of the given kind.","ref":"BubbleMatch.Token.html#entity?/2","title":"BubbleMatch.Token.entity?/2","type":"function"},{"doc":"Constructs a token from a Duckling entity definition","ref":"BubbleMatch.Token.html#from_duckling_entity/1","title":"BubbleMatch.Token.from_duckling_entity/1","type":"function"},{"doc":"Given a single token in Spacy's JSON format, convert it into a token.","ref":"BubbleMatch.Token.html#from_spacy/1","title":"BubbleMatch.Token.from_spacy/1","type":"function"},{"doc":"Constructs a token from a Spacy entity definition","ref":"BubbleMatch.Token.html#from_spacy_entity/2","title":"BubbleMatch.Token.from_spacy_entity/2","type":"function"},{"doc":"Test whether a token mathces the given POS (part-of-speech) tag.","ref":"BubbleMatch.Token.html#pos?/2","title":"BubbleMatch.Token.pos?/2","type":"function"},{"doc":"Test whether a token's raw value matches the given regular expression.","ref":"BubbleMatch.Token.html#regex?/2","title":"BubbleMatch.Token.regex?/2","type":"function"},{"doc":"Test whether a token matches the given (optionally normalized) word.","ref":"BubbleMatch.Token.html#word?/2","title":"BubbleMatch.Token.word?/2","type":"function"},{"doc":"Tokens contain the following fields:raw - the raw text value of the token, including any surrounding whitespace.value - the normalized value of the token. In the case of word tokens, this is usually the normalized, lowercased version of the word. In the case of entities, this value holds a map with keys kind, provider and value.start - the start index; where in the original sentence the token starts.end - the end index; where in the original sentence the token ends.index - the (zero-based) token index number; 0 if it's the first token, 1 if it's the second, etc.type - the type of the token; an atom, holding either :entity, :spacy, :naive, depending on the way the token was originally created.","ref":"BubbleMatch.Token.html#t:t/0","title":"BubbleMatch.Token.t/0","type":"type"}]